function modulo10(numberArray, verifyingDigit) {
  const result = calculateVerifyingDigitMod10(numberArray);
  return result == verifyingDigit;
}

function modulo11(numberArray, verifyingDigit) {
  const result = calculateVerifyingDigitMod11(numberArray);
  return verifyingDigit == result;
}

function calculateVerifyingDigitMod10(numberArray) {
  let multi = [];
  let flag = false;

  numberArray.reverse().forEach(digit => {
    if (!flag) {
      multi.push(parseInt(digit, 10) * 2);
      flag = true;
    } else {
      multi.push(parseInt(digit, 10));
      flag = false;
    }
  });

  multi = multi.join('');
  let sum = 0;

  [...multi].forEach(digit => {
    sum += parseInt(digit, 10);
  });

  let rest = sum % 10;
  let result = undefined;

  if (rest === 0) {
    result = 0;
  } else {
    result = 10 - rest;
  }

  return result;
}

function calculateVerifyingDigitMod11(numberArray) {
  let multiplier = 2;
  const multiplications = [];

  numberArray.reverse().forEach(digit => {
    multiplications.push(parseInt(digit, 10) * multiplier);
    multiplier += 1;

    if (multiplier > 9)
      multiplier = 2;
  });

  let sum = 0;

  multiplications.forEach(value => {
    sum += value;
  });

  const rest = sum % 11;
  let result;

  if (rest === 0 || rest === 1)
    result = 0;
  else if (rest === 10)
    result = 1;
  else
    result = 11 - rest;

  return result;
}

module.exports = {
  modulo10,
  calculateVerifyingDigitMod10,
  calculateVerifyingDigitMod11,
  modulo11
}
